import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

class AsyncHandlerTriggerApp extends CTWidget {
  const AsyncHandlerTriggerApp({super.key});

  @override
  Widget build(BuildContext context) {
    final loadTrigger = trigger();

    final result = loadTrigger.asyncHandler((_) async {
      await Future.delayed(const Duration(seconds: 1));
      return 'Loaded';
    });

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        Text(result.runtimeType.toString()),
        const SizedBox(height: 16),
        if (result is Failure) Text(result.failure().toString()),
        if (result is Success) Text(result.success().value),
        const SizedBox(height: 16),
        ElevatedButton(
          onPressed: loadTrigger,
          child: const Text('Load'),
        ),
      ],
    );
  }
}
