import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

class RefActionApp extends CTWidget {
  const RefActionApp({super.key});

  @override
  Widget build(BuildContext context) {
    final counter = ref(() => 0);

    final increment = counter.action((value) => value + 1);
    final decrement = counter.action((value) => value - 1);

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        const Text('You have pushed the button this many times:'),
        Text(
          '${counter.value}',
          style: Theme.of(context).textTheme.headlineMedium,
        ),
        const SizedBox(height: 16),
        ElevatedButton(
          onPressed: increment,
          child: const Text('Increment'),
        ),
        ElevatedButton(
          onPressed: decrement,
          child: const Text('Decrement'),
        ),
      ],
    );
  }
}
