part of './flutter_compute_tree.dart';

abstract class CTNode implements BuildContext {
  static CTNode? _target;

  static CTNode get currentTarget {
    if (_target == null) {
      throw Exception('Outside of compute tree');
    }
    return _target!;
  }

  T _exec<T>(T Function() fn) {
    _target = this;
    _units.enter();
    final v = fn();
    _units.exit();
    _target = null;
    return v;
  }

  late final _units = Units();

  void _signalUpdate();
}
