part of './flutter_compute_tree.dart';

abstract class CTWidget extends Widget {
  const CTWidget({super.key});

  Widget build(BuildContext context);

  bool shouldUpdate(
    CTNode node,
    covariant CTWidget oldWidget,
    covariant CTWidget newWidget,
  ) {
    return true;
  }

  @override
  CTElement createElement() {
    return CTElement(this);
  }
}

class CTElement extends ComponentElement with CTNode {
  CTElement(super.widget);

  @override
  CTWidget get widget => super.widget as CTWidget;

  Widget _build() {
    final w = widget.build(this);
    return w;
  }

  @override
  Widget build() {
    return _exec(_build);
  }

  @override
  void update(CTWidget newWidget) {
    super.update(newWidget);

    if (widget.shouldUpdate.call(this, widget, newWidget)) {
      markNeedsBuild();
    }
  }

  @override
  void unmount() {
    _units.dispose();
    super.unmount();
  }

  @override
  void _signalUpdate() {
    if (mounted) {
      markNeedsBuild();
    }
  }
}
