part of './flutter_compute_tree.dart';

class NodeBuilder extends CTWidget {
  final Widget Function(CTNode ctNode) builder;
  final bool Function(CTNode ctNode)? updateCondition;

  @override
  bool shouldUpdate(
    CTNode node,
    covariant CTWidget oldWidget,
    covariant CTWidget newWidget,
  ) {
    return updateCondition?.call(node) ?? false;
  }

  const NodeBuilder(
    this.builder, {
    super.key,
    this.updateCondition,
  });

  @override
  Widget build(BuildContext context) {
    return builder(context as CTNode);
  }
}
