part of './flutter_compute_tree.dart';

abstract class Unit<T, K> {
  late UnitKey<T, K> key;
  late CTNode _owner;

  void notify() {
    _owner._signalUpdate();
  }

  @mustCallSuper
  void init(CTNode node, K dep) {
    _owner = node;
  }

  @mustCallSuper
  Unit<T, K> update(
    CTNode node,
    K oldDep,
    K newDep,
    covariant Unit<T, K> newUnit,
  ) {
    _owner = node;
    return this;
  }

  @mustCallSuper
  void dispose() {}

  T unwrap();
}
