part of './flutter_compute_tree.dart';

class UnitEntry<T, K> {
  UnitKey<T, K> key;
  Unit<T, K> unit;
  final CTNode node;

  UnitEntry(this.key, this.unit, this.node) {
    unit.key = key;
  }

  void init(K dep) {
    unit.init(node, dep);
  }

  void update(K oldDep, UnitKey<T, K> newKey, covariant Unit<T, K> newUnit) {
    key = newKey;
    unit = unit.update(node, oldDep, newKey._value, newUnit);
  }

  void dispose() {
    unit.dispose();
  }
}
